//+------------------------------------------------------------------+
//|                                                201104_115143.mqh |
//|                                    2019-2020, dimitri pecheritsa |
//|                                                 792112@gmail.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| class 201104_115216                                   originator |
//+------------------------------------------------------------------+
#include <Mqh\201104_114823.mqh> //memento
//   memento pattern participant
//---
class Originator
  {
protected:
   string            m_state;
public:
   void              SetMemento(Memento& memento);
   Memento*          CreateMemento(void);
   string            State(void);
   void              State(string);
  };
//+------------------------------------------------------------------+
//| method 201104_115324                                 set memento |
//+------------------------------------------------------------------+
void Originator::SetMemento(Memento& memento)
  {
   m_state=memento.GetState();
   printf("restoring originator state from memento to %s",m_state);
  }
//+------------------------------------------------------------------+
//| method 201104_115430                              create memento |
//+------------------------------------------------------------------+
Memento* Originator::CreateMemento(void)
  {
   printf("creating memento with current state %s",m_state);
   return new Memento(m_state);
  }
//+------------------------------------------------------------------+
//| method 201104_115511                                   set state |
//+------------------------------------------------------------------+
void Originator::State(string state)
  {
   printf("changing originator state to %s",state);
   m_state=state;
  }
//+------------------------------------------------------------------+
//| method 201104_115553                                   get state |
//+------------------------------------------------------------------+
string Originator::State(void)
  {
   return m_state;
  }
//+------------------------------------------------------------------+
